﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication1
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<DhpComboItem> itemList = new List<DhpComboItem>() {
                new DhpComboItem(1, "one"),
                new DhpComboItem(2, "two"),
                new DhpComboItem("drei", "three"),
                new DhpComboItem(4, "four")
            };

            ComboBoxItemsProvider provider = new ComboBoxItemsProvider();
            provider.ItemsSource = itemList;
            provider.ValuePath = "Value";
            provider.DisplayMemberPath = "DisplayText";

            this.xamComboEditor1.ValueType = typeof(object);
            this.xamComboEditor1.ItemsProvider = provider;
            //this.xamComboEditor1.DisplayValueSource = DisplayValueSource.Value;

            this.xamComboEditor1.SelectedIndex = 0;
        }

        private void xamComboEditor1_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            this.xamComboEditor1.Text = ((DhpComboItem)this.xamComboEditor1.SelectedItem).LabelText;
        }
    }

    public class DhpComboItem
    {
        public DhpComboItem(object value, string labelText)
        {
            Value = value;
            LabelText = labelText;
        }

        public object Value { get; set; }

        public string LabelText { get; set; }

        public string DisplayText
        {
            get
            {
                string displayText = string.Empty;

                if (Value != null)
                    displayText = Value.ToString() + "\t";

                return displayText + LabelText;
            }
        }
    }
}